import java.util.ArrayList;
import java.util.Collections;

public class Person implements Comparable<Person>
{
    private String firstName;
    private String lastName;
    private int id;
    
    public Person(String firstName, String lastName, int id)
    {
        this.firstName = firstName;
        this.lastName = lastName;
        this.id = id;
    }
    
    public int getId()
    {
        return id;
    }
    
    public int compareTo(Person p){
        int ret = this.lastName.compareTo(p.lastName);
        
        if(ret == 0) {
            return this.firstName.compareTo(p.firstName);
        }else{
            return ret;
        }
    }
    
    public String toString()
    {
        return lastName + ", " + firstName + " (" + id + ")";
    }
    
    public static void displayList(ArrayList<Person> list) 
    {
        System.out.println("######");
        for(int i = 0; i < list.size(); ++i) {
            System.out.println(list.get(i));
        }
    }
    
    
    
    
    
    @Override
    public int hashCode()
    {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((firstName == null) ? 0 : firstName.hashCode());
        result = prime * result + id;
        result = prime * result + ((lastName == null) ? 0 : lastName.hashCode());
        return result;
    }
    

    @Override
    public boolean equals(Object obj)
    {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        Person other = (Person) obj;
        if (firstName == null)
        {
            if (other.firstName != null)
                return false;
        }
        else if (!firstName.equals(other.firstName))
            return false;
        if (id != other.id)
            return false;
        if (lastName == null)
        {
            if (other.lastName != null)
                return false;
        }
        else if (!lastName.equals(other.lastName))
            return false;
        return true;
    }

    public static void main(String[] args)
    {
        Person p1 = new Person("Robert", "Duvall", 1138);
        Person p2 = new Person("Donald", "Pleasence", 5241);
        Person p3 = new Person("Maggie", "McOmie", 3417);
        Person p4 = new Person("Bob", "Duvall", 10);
        ArrayList<Person> list = new ArrayList<Person>();
        list.add(p1);
        list.add(p2);
        list.add(p3);
        list.add(p4);
        displayList(list);
        
        Collections.sort(list);
        
        displayList(list);
        
        PersonComparator pc = new PersonComparator();
        
        Collections.sort(list, pc);
        
        displayList(list);
        
    }
}
